#include <graphics.h>
#include <alloc.h>
#include <mem.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <fcntl.h>

class c_switch
 {
  int px,py;
  int state;
  char **sbmp;

 public:
  int getstate( void );
  void setstate( int nws );
  void draw( void );

  c_switch( char **bmp, int xx, int yy, int instate=0 );
 };

char *loadbitmap( char *fnev );

/******************************************/

void main ( void )
{
 c_switch *swt[10];
 char **b1;

 b1=(char **)malloc( 4 * 10 );
 b1[0]=loadbitmap("s_off.ns");
 b1[1]=loadbitmap("s_on.ns");
 b1[2]=NULL;
 c_switch sw1(b1,50,50);

 b1=(char **)malloc( 4 * 10 );
 b1[0]=loadbitmap("k2_off.ns");
 b1[1]=loadbitmap("k2_on.ns");
 b1[2]=NULL;
 c_switch sw2(b1,100,50);

 b1=(char **)malloc( 4 * 10 );
 b1[0]=loadbitmap("k3_off.ns");
 b1[1]=loadbitmap("k3_on.ns");
 b1[2]=NULL;
 c_switch sw3(b1,150,50);

 b1=(char **)malloc( 4 * 10 );
 b1[0]=loadbitmap("k4_off.ns");
 b1[1]=loadbitmap("k4_on.ns");
 b1[2]=NULL;
 c_switch sw4(b1,200,50);

 swt[0]=&sw1;
 swt[1]=&sw2;
 swt[2]=&sw3;
 swt[3]=&sw4;

 /* request auto detection */
 int gdriver = DETECT, gmode, errorcode;

 /* initialize graphics mode */
 initgraph(&gdriver, &gmode, "");

 /* read result of initialization */
 errorcode = graphresult();

 if (errorcode != grOk)  /* an error occurred */
 {
    printf("Graphics error: %s\n", grapherrormsg(errorcode));
    printf("Press any key to halt:");
    getch();
    exit(1);             /* return with error code */
 }
 int c;

 for ( c=0 ; c<=3 ; c++ )
  swt[c]->draw();

 int kar;
 do
  {
   kar=getch();
   if ( '0'<=kar && kar<='9' )
    swt[kar-'0']->setstate(0);
  }
 while (kar!=27);

 /* clean up */
 // getch();
 closegraph();
}

/******************************************/

char *loadbitmap( char *fnev )
{
 int bmfile;
 unsigned int sx,sy;
 char *buffer;

 if ( (bmfile=open(fnev,O_BINARY|O_RDWR)) == -1 )
  return( NULL );

 read( bmfile, &sx , 2 );
 read( bmfile, &sy , 2 );

 buffer=(char *)malloc( sx*sy +6 );
 lseek( bmfile,0,SEEK_SET );
 if ( read( bmfile,buffer,sx*sy+4 )<=0 )
  return( NULL );

 close(bmfile);
 return( buffer );
}

/************************************/

int c_switch::getstate( void )
{
 return(state);
}

void c_switch::setstate( int nws )
{
 if (nws==0)
  {
   state++;
   if (sbmp[state]==NULL)
    state=0;
   draw();
   return;
  }
}

void c_switch::draw ( void )
{
 putimage( px,py , sbmp[state] , 0 );
}

void c_switch::c_switch( char **bmp , int xx, int yy, int instate )
{
 int cn=-1;
 while (bmp[cn] != NULL ) cn++;

 sbmp=(char **)malloc( 4*cn + 5 );

 memcpy(sbmp,bmp,4*cn);

 px=xx; py=yy;
 sbmp=bmp;
 state=instate;
}

