#if 0
-------------------------------------------------------------------------------
Name:		PKFF.C
Description:	File Find Utility
Version:	1.10
Hardware:	IBM PC/XT/AT/PS2
Op. System:	PC/MS DOS 3.30
Compiler:	Turbo C 2.0
Author:		Mikls Pl
-------------------------------------------------------------------------------
#endif

/* include files */

#include <stdio.h>
#include <conio.h>
#include <process.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>
#include <dos.h>
#include <io.h>

/* macro functions */

#define sizeofarray(array) (sizeof(array)/sizeof(array[0]))

/* structures */
struct arc_head
	{
	char signature;
	char c_method;
	char name[MAXFILE+MAXEXT-1];
	unsigned long c_size;
	unsigned short date;
	unsigned short time;
	unsigned short crc16;
	unsigned long uc_size;
	};

struct zip_head
	{
	long signature;
	int vextract;
	int gpflag;
	int c_method;
	unsigned short time;
	unsigned short date;
	unsigned long crc32;
	unsigned long c_size;
	unsigned long uc_size;
	int l_filename;
	int l_extra;
	};
/*************
struct shtime
	{
	unsigned short time;
	unsigned short date;
	};

union f2time
	{
	struct shtime shtd;
	struct ftime ftd;
	};

struct videocfg
	{
	unsigned char winleft0;		* window settings -1 *
	unsigned char wintop0;
	unsigned char winright0;
	unsigned char winbottom0;
	unsigned char curratr;		* attributes *
	unsigned char normattr;
	unsigned char dspmode;		* display mode *
	unsigned char scheight;		* display size *
	unsigned char scwidth;
	unsigned char graphic;		* graphic mode indicator *
	unsigned char snoweff;		* snow effect indicator *
	unsigned char far *videoptr;	* video memory pointer *
	};
*************/

/* stack */

//extern struct videocfg _video;		/* standard tc 2.0 library */
//extern unsigned _stklen=0x4000;		/* redefine the stack size */

/* global data */

int arcview( char *name );
int zipview( char *name );

void main ( void )
{
 //arcview( "TESZT.ARC" );
 zipview( "TESZT.ZIP" );
}

int arcview( char *name )
{
 FILE *fptr;
 arc_head archd;

 if((fptr=fopen(name,"rb"))==NULL)
  {
   return( -1 );
  }
 for(;;)
  {
   if(fread(&archd,sizeof(archd),1,fptr)!=1)
    {
     break;
    }
   if((archd.signature!='\x1a')||(archd.c_method<'\0')||(archd.c_method>'\x09')||(memchr(archd.name,'\0',13)==NULL))
    {
     break;
    }
   if(1/*strmatch(name,archd.name)*/)
    {
     //found=1;
     //found_n++;
     printf("\n %s ",archd.name);
     printf("%*c",14-strlen(archd.name),'\x20');
     printf("(%s)",name);
     printf("%*c",14-strlen(name),'\x20');
     //printf_info(archd.uc_size,archd.date,archd.time);
    }
   fseek(fptr,archd.c_size,SEEK_CUR);
  }
 fclose(fptr);
 return( 0 );
}

int zipview( char *name )
{
 FILE *fptr;
 zip_head ziphd;
 static char zipname[MAXFILE+MAXEXT-1];
 static int zindex;
 static char nindex;

 if((fptr=fopen(name,"rb"))==NULL)
  {
   return( -1 );
  }

 for(;;)
  {
   if(fread(&ziphd,sizeof(ziphd),1,fptr)!=1)
    {
     break;
    }
   if(ziphd.signature!=0x04034b50L)
    {
     break;
    }
   nindex=0;
   for(zindex=0;zindex<ziphd.l_filename;zindex++)
    {
     if(nindex==sizeof(zipname))
      {
       break;
      }
     if((zipname[nindex++]=fgetc(fptr))=='/')
      {
       nindex=0;
      }
    }
   zipname[nindex]='\0';
   for(zindex=0;zindex<ziphd.l_extra;zindex++)
    {
     fgetc(fptr);	// throw away extra field *
    }
   if(1/*strmatch(name,zipname)*/)
    {
     //found=1;
     //found_n++;
     printf("\n  %s",zipname);
     printf("%*c",14-strlen(zipname),'\x20');
     printf("(%s)",name);
     printf("%*c",14-strlen(name),'\x20');
     //printf_info(ziphd.uc_size,ziphd.date,ziphd.time);
    }
   fseek(fptr,ziphd.c_size,SEEK_CUR);
  }
 fclose(fptr);
 return( 0 );
}
